Description

Supportanfrage

ich habe eine Anfrage zu der ich in der Doku auch nicht viel gefunden habe:

ADTF3 hat einen RPC Mechanismus, damit adtf_control mit adtf_launcher kommunizieren kann.

Dieser RPC Mechanismus basiert auf jsonrpc-cpp, welcher wiederum http POST benutzt.

Meine Hoffnung: http POST kann auch von einer simplen Website genutzt werden, um z.B. das Runlevel der ADTF Instanzen

anzuzeigen und das Runlevel zu ändern.

Leider ist die Dokumentation dazu etwas dünn und nach ersten

Versuchen klappt die Kommunikation noch nicht.

Grunsätzlich habe ich versucht in einer lokalen html-Datei

mit JavaScript XMLHttpRequest zu nutzen, um das Runlevel auszulesen

Firefox liefert mir z.B: folgende Fehlermeldung:

Cross-Origin

Request Blocked: The Same Origin Policy disallows reading the remote resource

at http://localhost:8000/system. (Reason: CORS

request did not succeed).

Frage:

Gibt es Einschränkungen, was mit simplen HTML5/JavaScript möglich ist? (würde im ersten Schritt Abhängigkeiten zu PHP

oder Bibliotheken vermeiden wollen, um eine einfache Inbetriebnahme zu ermöglichen)

Wie kann/muss ich den RPC-Server konfigurieren, damit die Kommunikation mit dem Browser klappt? (Ggf. sind hier aus

Sicherheitsgründen Features deaktiviert)

 Er nutzt ADTF 3.11.2. Er probierte auch die Python basierte Communication in den Beispielscripten:

just tried python and it simply worked:

import requests

url = 'http://localhost:8000/system'

myobj = {'id': '1', 'jsonrpc': '2.0', 'method': 'GetRunlevel'}

x = requests.post(url, json = myobj)

print(x.text)

However it would be cool having something which just need a browser without any further dependencies. Just HTML5,

JavaScript

 Gibt es eine Möglichkeit ADTF simple über den Browser steuern zu können?

Lösung
http://localhost:8000/system


Das klappt auch mt einem Browser, mann muss allerdings CORS zulassen. Browser lassen eine Website standardmäßig keine

Verbindung zu einem anderen Server aufbauen. Das kann man entweder dadurch lösen, dass man die Datei über einen Webserver

ausspielt und entsprechende Header setzt oder aber man installiert sich eine Browser Erweiterung und deaktiviert damit die CORS

Einschränkungen, z.b. https://chrome.google.com/webstore/detail/allow-cors-access-control/lhobafahddgcelffkeicbaginigeejlf

History

#1 - 2021-05-04 12:12 - hidden

- Status changed from New to In Progress

- Customer set to ELEKTROBIT

- Department set to SUPPORT

- Topic set to ADTF::RPC

#2 - 2021-05-04 12:31 - hidden

Hi Anja,

das klappt auch mt einem Browser, mann muss allerdings CORS zulassen. Browser lassen eine Website standardmäßig keine Verbindung zu einem

anderen Server aufbauen. Das kann man entweder dadurch lösen, dass man die Datei über einen Webserver ausspielt und entsprechende Header

setzt oder aber man installiert sich eine Browser Erweiterung und deaktiviert damit die CORS Einschränkungen, z.b. 

https://chrome.google.com/webstore/detail/allow-cors-access-control/lhobafahddgcelffkeicbaginigeejlf

Grüße,

Martin

#3 - 2021-05-06 17:46 - hidden

- Private changed from No to Yes

#4 - 2021-05-10 13:02 - hidden

Hallo Anja,

benötigst du noch weitere Unterstützung? Ansonsten würden wir das Ticket schließen.

Grüße

Margarete

#5 - 2021-05-10 13:02 - hidden

- Status changed from In Progress to Customer Feedback Required

#6 - 2021-05-12 08:39 - hidden

Hallo Margarete,

ich habe noch keine Rückmeldung bekommen.

Grüße,

Anja

#7 - 2021-05-12 08:43 - hidden

Hallo,

das ticket kann geschlossen werden. Danke.

Viele Grüße,

Anja

#8 - 2021-05-12 10:49 - hidden

- Project changed from 7 to Public Support

- Description updated

- Status changed from Customer Feedback Required to To Be Closed

- Private changed from Yes to No

- Resolution set to Solved Issue

- Affected Products ADTF 3.11.2 added
#9 - 2021-05-12 10:49 - hidden

- Status changed from To Be Closed to Closed
